
import com.hazelcast.core.HazelcastInstance;
import com.hazelcast.core.HazelcastInstanceAware;
import com.hazelcast.map.IMap;
import java.io.Serializable;
import java.util.concurrent.Callable;

public class ClusterTask implements  Callable<String>, Serializable, HazelcastInstanceAware {
  
  private final String[] keys;
  
  // HZ instance must be transient to prevent it from the serialization
  private transient HazelcastInstance hz;
  
  public ClusterTask(String[] keys) {
    this.keys = keys;
  }

  @Override
  public String call() throws Exception {
    
    String res = " Instance name: "+hz.getCluster().getLocalMember().getAddress().toString();
    
    IMap<String, Person> map = hz.getMap("dbMap");
    for(String key: keys){
      res+="\n"+map.get(key);
    }
    res+="\n";
    
    return res;
  }

  @Override
  public void setHazelcastInstance(HazelcastInstance hz) {
    this.hz = hz;
  }
  
  
}
