import com.hazelcast.config.Config;
import com.hazelcast.config.MapConfig;
import com.hazelcast.config.MapStoreConfig;
import com.hazelcast.core.Hazelcast;
import com.hazelcast.core.HazelcastInstance;
import com.hazelcast.map.IMap;
import java.util.concurrent.TimeUnit;


public class Member {
  

    private static int DB_WRITE_DELAY_S;
    
    private static final Integer DB_WRITE_DELAY_S_DEFAULT=10;
    private static final String DB_WRITE_DELAY_KEY="DB_WRITE_DELAY";
    private static final String PARMS_INITED_KEY = "PARMS_INITED";
    private static final int N_RECORDS = 10000;
      
    private static void initClusterWideParams(HazelcastInstance hz){
        IMap<String,String> configMap =  hz.getMap("clusterConfigMap");
        String lockKey="1";
        boolean inited = Boolean.parseBoolean(configMap.get(PARMS_INITED_KEY));
        if ( !inited ) {
          configMap.lock(lockKey);
          configMap.put(DB_WRITE_DELAY_KEY, DB_WRITE_DELAY_S_DEFAULT.toString());         
          configMap.put(PARMS_INITED_KEY, Boolean.TRUE.toString());
          configMap.unlock(lockKey);
          
        }        
        DB_WRITE_DELAY_S = Integer.parseInt(configMap.get(DB_WRITE_DELAY_KEY));
    }
    
  public static void main(String[] args) throws Exception {

    Config config = new Config();


    HazelcastInstance hz = Hazelcast.newHazelcastInstance(config);
    initClusterWideParams(hz);
        
    //configure map to be stored in DB
    MapConfig mapConfig = new MapConfig("dbMap");
    
    MapStoreConfig mapStoreConfig = new MapStoreConfig();
    mapStoreConfig.setClassName(PersonMapStore.class.getName());
    mapStoreConfig.setWriteDelaySeconds(DB_WRITE_DELAY_S);
    mapStoreConfig.setOffload(true);    
    mapConfig.setMapStoreConfig(mapStoreConfig);
    hz.getConfig().addMapConfig(mapConfig);    
    
    System.out.println("Hazelcast Member instance is running!");


    IMap<String, Person> map = hz.getMap("dbMap");
    for(;;) {
        System.out.println("============ Current map size: "+map.size()+" records ============");
        TimeUnit.SECONDS.sleep(2);
    }
  }

}
