
import com.hazelcast.map.MapStore;
import static java.lang.String.format;
import java.sql.Connection;
import java.sql.DriverManager;
import java.sql.PreparedStatement;
import java.sql.ResultSet;
import java.sql.SQLException;
import java.util.Collection;
import java.util.HashMap;
import java.util.HashSet;
import java.util.Map;
import java.util.Set;
import java.util.logging.Level;
import java.util.logging.Logger;

public class PersonMapStore implements MapStore<String, Person> {

  public static String MYSQL_HOST = "192.168.0.174";
  public static String MYSQL_DB = "hz_db";

  private final Connection con;
  private final PreparedStatement allKeysStatement;

  public PersonMapStore() {
    try {
      con = DriverManager.getConnection("jdbc:mysql://" + MYSQL_HOST + ":3306/hz_db", "hz", "password");
      con.createStatement().executeUpdate(
        "create table if not exists person (id varchar(200) not null, name varchar(200), primary key (id))");
      allKeysStatement = con.prepareStatement("select id from person");
    } catch (SQLException e) {
      throw new RuntimeException(e);
    }
  }

  @Override
  public synchronized void delete(String key) {
    System.out.println("Delete:" + key);
    try {
      con.createStatement().executeUpdate(
        format("delete from person where id = %s", key));
    } catch (SQLException e) {
      throw new RuntimeException(e);
    }
  }

  @Override
  public synchronized void store(String key, Person value) {
    try {
      con.createStatement().executeUpdate(
        format("REPLACE INTO person VALUES('%s','%s')", key, value.getName()));
    } catch (SQLException e) {
      throw new RuntimeException(e);
    }
  }

  @Override
  public synchronized void storeAll(Map<String, Person> map) {
    for (Map.Entry<String, Person> entry : map.entrySet()) {
      store(entry.getKey(), entry.getValue());
    }
  }

  @Override
  public synchronized void deleteAll(Collection<String> keys) {
    for (String key : keys) {
      delete(key);
    }
  }

  @Override
  public synchronized Person load(String key) {
    try {
      try (ResultSet resultSet = con.createStatement().executeQuery(
        format("select name from person where id ='%s'", key))) {
        if (!resultSet.next()) {
          return null;
        }
        String name = resultSet.getString(1);
        return new Person(key, name);
      }
    } catch (SQLException e) {
      throw new RuntimeException(e);
    }
  }

  @Override
  public synchronized Map<String, Person> loadAll(Collection<String> keys) {
    Map<String, Person> result = new HashMap<>();
    for (String key : keys) {
      result.put(key, load(key));
    }
    return result;
  }

  @Override
  public Set<String> loadAllKeys() {

    Set<String> res = new HashSet<>();
    try {
      ResultSet rs = allKeysStatement.executeQuery();
      while (rs.next()) {
        res.add(rs.getString(1));
      }
    } catch (SQLException ex) {
      Logger.getLogger(PersonMapStore.class.getName()).log(Level.SEVERE, null, ex);
    }
    return res;
  }
}
